;
$DATE (10.12.2003)
$TITLE (BinToDec.a51)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;

;********************************************************************************************************
; Berechnen einer Zufallszahl (0 .. 255), Umsetzen in Dezimalzahl und 
; Schreiben ber die serielle Schnittstelle (direkt)
; J. Rathlev, Dez. 2003
;********************************************************************************************************

      NAME      BINTODEC

;********************************************************************************************************
; Konstanten
; ==========

CODEMEM EQU     8000H

LED     EQU     P1.7    ; Portanschluss fr LED

;********************************************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

;********************************************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

;********************************************************************************************************

        ORG     CODEMEM+30H

$INCLUDE(Includes\Random.a51)
$INCLUDE(Includes\SerInOut.a51)

;********************************************************************************************************
; Hauptprogramm

Start:  MOV     SP,#STACKSTART
        MOV     A,#250          ; BR-Count (Serint.a51)
        CALL    InitSerial
        CALL    InitRnd         ; Zufallszahlengenerator initialisieren
        MOV     DPTR,#TEXT      ; Begrungstext
        CALL    WriteFixStr
LOOP:   JNB     RI,LOOP         ; warten
        CLR     RI
        MOV     A,SBUF          ; Zeichen lesen
        
        MOV     DPTR,#TEXT1     
        CALL    WriteFixStr
        CALL    GetRnd          ; Zufallszahl erzeugen
        CPL     A
        MOV     P1,A            ; anzeigen
        CPL     A
        SETB    C
        CALL    WriteDec        ; als Dezimalzahl senden
        CALL    WriteCR
        SJMP    LOOP


TEXT:   DB      'Hallo, hier ist der Mikrocontroller!',13,10,'Tippen Sie ein Zeichen: ',0
Text1:  DB      'Zufallszahl: ',0

;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; stack: rest of data memory

END
