;
$DATE (22.12.2019)
$TITLE (DecConvert)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;

;********************************************************************************************************
; Lesen einer Zahl (0 .. 65535) ber die serielle Schnittstelle (direkt), Umsetzen in Binrwert und 
; Anzeigen an LED (Port 1)
; J. Rathlev, Dez. 2019
;********************************************************************************************************

      NAME      DecConvert

;********************************************************************************************************
; Konstanten
; ==========

CODEMEM EQU     8000H

LED     EQU     P1.7    ; Portanschluss fr LED

;********************************************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

Value:  DS      2
Divi:   DS      2
        
;********************************************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

;********************************************************************************************************

        ORG     CODEMEM+30H

$INCLUDE(SerInOut.a51)
;$INCLUDE(SerInOutBuf.a51)

;********************************************************************************************************
; Hauptprogramm

Start:  MOV     SP,#STACKSTART
        MOV     A,#244          ; BR-Count (Serint.a51)
        CALL    InitSerial
;        CALL    InitSerInput
;        SETB    EA              ; Enable Global-Interrupt
        MOV     DPTR,#TEXT1     ; Begrungstext
        CALL    WRITEFIXSTR

NEW:    MOV     DPTR,#TEXT2     ; Eingabeaufforderung
        CALL    WRITEFIXSTR
        CALL    READDEC
        SETB    C
        CALL    WRITEDEC
        JMP     NEW
        
TEXT1:   DB     'Hallo, hier ist der Mikrocontroller!',0
TEXT2:   DB     13,10,'Geben Sie eine Zahl ein: ',0
     
;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; stack: rest of data memory

END
