$NOLIST

; Include Datei

;********************************************************************************************************
; Zufallsszahlen-Generator (0..255)
; J. Rathlev, Mrz 2006
;********************************************************************************************************
        DSEG

FIRSTRND EQU    55H     ; Anfangswert fr Zufallszahlen

RANDOM: DS 1

;********************************************************************************************************
        CSEG

;********************************************************************************************************
; Zufallszahl initialisieren

INITRND:
        MOV     RANDOM,#FIRSTRND        ; festen Anfangswert setzen
        RET

;********************************************************************************************************
; Zufallszahl berechnen (Algorithmus nach  D.H. Lehmer (1948))
; x(n+1) = (a*x(n)+c) mod 256 mit a = 37, c = 53
; Zufallszahl in A und RANDOM

GETRND: 
        MOV     A,RANDOM
        MOV     B,#37
        MUL     AB
        ADD     A,#53
        MOV     RANDOM,A
        RET

$LIST
